function [Out,bDs,Errors]=set_mtimes(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('dl',[2,2],@(x) ismember(length(x),[1,2]));
  p.addParamValue('dr',[2,2],@(x) ismember(length(x),[1,2]));
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.addParamValue('ltype','array3d',@(s) ismember(lower(s),{'array3d','array2d','array1d','constant'}));
  p.addParamValue('rtype','array3d',@(s) ismember(lower(s),{'array3d','array2d','array1d','constant'}));
  p.parse(varargin{:});
  R=p.Results;
  %mattype=R.mattype;
  R.ltype=lower(R.ltype);R.rtype=lower(R.rtype);
  Fprintf=R.fprintf;
  dl=R.dl;dr=R.dr;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  assert( strcmp(R.ltype,'array3d') || strcmp(R.rtype,'array3d') )
  if verbose
    Fprintf('# Prototype functions: Z=fun(X,Y)\n');
    Fprintf('# Computes X*Y.\n');
  end
  if verbose, Fprintf('# 1st parameter is :\n');end
  [X,~]=fc_linalg3D.benchs.set_datas(N,verbose,'d',dl,'type',R.ltype,varargin{:});
  if verbose, Fprintf('# 2nd parameter is :\n');end
  [Y,~]=fc_linalg3D.benchs.set_datas(N,verbose,'d',dr,'type',R.rtype,varargin{:});
  Errors={};
  bDs{1}=fc_bench.bdata('N',N,'%d',10);
  Out={X{1},Y{1}};
end
