function [Out,bDs,Errors]=set_sympd(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('d',2,@isscalar);
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.parse(varargin{:});
  R=p.Results;
  %mattype=R.mattype;
  Fprintf=R.fprintf;
  d=R.d;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  A=fc_linalg3D.random.randnsympd(N,d);
  if verbose
    Fprintf('# Symmetric Positive Definite matrices\n');
    Fprintf('# -> 3D-array with (N,m1,n1)=(%d,%d,%d),  size=[%s]\n',N,d,d,num2str(size(A)));
  end
  Errors={};
  bDs{1}=fc_bench.bdata('N',N,'%d',10);
  Out={A};
end


