function D=detMixIdx_Vec(A,varargin)
% Only for symmetric/hermitian positive definite matrices
% A : N-by-d-by-d
% D : N-by-1
% D(i) = det A(i,:,:)
% https://www.researchgate.net/profile/Omid_Rezaifar/publication/220561323_A_new_approach_for_finding_the_determinant_of_matrices/links/59c0974baca272aff2e21691/A-new-approach-for-finding-the-determinant-of-matrices.pdf
% ATTENTION: Take care with this formula, division by zero is possible! Even if the A(i,:,:) are symmetric definite positve.
% So not really usefull for numerical computation
% Formula modified by F.C. to work with symmetric/hermitian positive definite matrices A(i,:,:)
  assert( fc_linalg3D.is3Darray(A) && size(A,2)==size(A,3) )
  assert( ismember(nargin,[1,3]) )
  N=size(A,1);d=size(A,2);
  if nargin==1 
    I=1:d;J=1:d;
    m=d;
  else
    I=varargin{1};J=varargin{2};
    assert(length(I)==length(J))
    m=length(I);
  end
  %D=zeros(N,1);
  if m==0, D=1;return; end
  if m==1
    D=A(:,I(1),J(1));
    return
  end
  if m==2
    D=(A(:,I(1),J(1)).*A(:,I(2),J(2))-A(:,I(1),J(2)).*A(:,I(2),J(1)));
    return
  end
  I1=I(2:end);J1=J(2:end);
  Id=I(1:end-1);Jd=J(1:end-1);
  I2=I(2:end-1);J2=J(2:end-1);
  D=(fc_linalg3D.det.detMixIdx_Vec(A,I1,J1).*fc_linalg3D.det.detMixIdx_Vec(A,Id,Jd)- ...
     fc_linalg3D.det.detLapIdx_Vec(A,I1,Jd).^2 ) ./ ...
     fc_linalg3D.det.detMixIdx_Vec(A,I2,J2);
end
