function X=tril_Mat(A,B)
% A : N-by-d-by-d 
% b : N-by-d-by-m or N-by-d or d-by-m      or d-by-1
% x : N-by-d-by-m or N-by-d or N-by-d-by-m or N-by-d
  assert(fc_linalg3D.is3Darray(A));
  [N,m,n]=size(A);
  [dimA,dimB]=fc_linalg3D.getDimensions(A,B);
  assert( dimA(2)==dimA(3) && dimA(3)==dimB(2) );
  getB=fc_linalg3D.getMat(B,N);
  
  X=zeros(N,dimA(2),dimB(3));
  for k=1:N
    X(k,:,:)=linsolve_tril(squeeze(A(k,:,:)),getB(B,k));
  end
end

function x=linsolve_tril(A,b)
  dim=size(b);
  x=zeros(dim);
  for i=1:dim(1)
    for l=1:dim(2)
      x(i,l)=(b(i,l)-A(i,1:i-1)*x(1:i-1,l))/A(i,i);
    end
  end
end

function x=linsolve_tril_vec(A,b)
  dim=size(b);
  x=zeros(dim);
  for i=1:dim(1)
    x(i,:)=(b(i,:)-A(i,1:i-1)*x(1:i-1,:))/A(i,i);
  end
end

